float lum(vec3 v) { 
return dot(v, vec3(0.2126f, 0.7152f, 0.0722f)); 
} 

vec3 jodie_reinhard_tonemap(vec3 v) { 
    float l = lum(v); 
    vec3 tv = v / (1.0f + v);
return mix(v / (1.0f + l), tv, tv); 
}

//https://knarkowicz.wordpress.com/2016/01/06/aces-filmic-tone-mapping-curve.
vec3 acesFilm(vec3 x) { 
	float A = 3.5;
	float B = 0.1;
	float C = 0.7;
	float D = 0.6;
	float E = 0.02;
	float F = 0.5;
return (((x * (A * x + C * B) + D * E) / (x * (A * x + B) + D * F)) - E / F);
}
